<!doctype html>
<html>
<head>
    <title>Announcing the Vanguards Add-On for Onion Services | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Announcing the Vanguards Add-On for Onion Services | Tor Project">
    <meta property="og:description" content="Fixing the guard discovery problem in Tor itself is an immense project -- primarily because it involves many trade-offs between performance and scalability versus path security, which makes it very hard to pick good defaults for every onion service. Because of this, we have created an add-on that can be used in conjunction with a Tor onion service server or a Tor client that accesses Tor onion services.">
    <meta property="og:image" content="https://blog.torproject.org/announcing-vanguards-add-onion-services/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/announcing-vanguards-add-onion-services/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Announcing the Vanguards Add-On for Onion Services
      </h1>
    <p class="meta">by asn | July 20, 2018</p>
    <picture>
      
      <img class="lead" src="lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <h1>An Intro to Onion Service Security</h1>
<p>Earlier this year, the Tor Project released its first stable Tor and Tor Browser releases with <a href="https://blog.torproject.org/tors-fall-harvest-next-generation-onion-services">the new v3 onion service protocol</a>. The protocol features many improvements, including longer and more secure onion addresses, service enumeration resistance, improved authentication, and upgraded cryptography.</p>
<p>However, while this new protocol closes off some attacks (particularly enumeration and related targeted DoS attacks), it does not solve any attacks that could lead to service deanonymization.</p>
<p>We believe that the most serious threat that v3 onion services currently face is <em>guard discovery</em>. A guard discovery attack enables an adversary to determine the guard node(s) that are in use by a Tor client and/or Tor onion service. Once the guard node is known, traffic analysis attacks that can deanonymize an onion service (or onion service user) become easier.</p>
<p>The most basic form of this attack is to make many connections to a Tor onion service, in order to force it to create circuits until one of the adversary's nodes is chosen for the middle hop next to the guard. That is possible because middle hops for rendezvous circuits are picked from the set of all relays:</p>
<p class="text-align-center"><a href="https://raw.githubusercontent.com/asn-d6/vanguard_simulator/illustrations/illustrations/current_system.jpg"><img height="400" src="https://raw.githubusercontent.com/asn-d6/vanguard_simulator/illustrations/illustrations/current_system.jpg" /></a></p>
<p>A traffic analysis side channel can be used to confirm that the malicious node is in fact part of the rendezvous circuit, leading to the discovery of that onion service's guard node. From that point, the guard node can be compromised, coerced, or surveilled to determine the actual IP address of the onion service or client.</p>
<h1>The Vanguards Control Port Add-On</h1>
<p>Fixing the guard discovery problem in Tor itself is an immense project -- primarily because it involves many trade-offs between performance and scalability versus path security, which makes it very hard to pick good defaults for every onion service.</p>
<p>Because of this, we <a href="https://github.com/mikeperry-tor/vanguards">have created an add-on</a> that can be used in conjunction with a Tor onion service server or a Tor client that accesses Tor onion services.</p>
<p>The add-on uses <a href="https://gitweb.torproject.org/torspec.git/tree/control-spec.txt">our Control Port Protocol</a> and the corresponding <a href="https://stem.torproject.org/">Stem Library</a> to defend against these attacks. The hope is that it will we will be able to study the performance and functionality of this feature and gather feedback before we deploy these changes in Tor for all onion services and clients.</p>
<h1>Vanguards, Bandguards, and a Rendguard, oh my!</h1>
<p>Our add-on has three components:</p>
<h3>Vanguards</h3>
<p>The core functionality is provided by the <strong>Vanguards</strong> <strong>component</strong> which implements the <a href="https://gitweb.torproject.org/torspec.git/tree/proposals/292-mesh-vanguards.txt">Mesh Vanguards (Proposal 292)</a>. This ensures that all onion service circuits are restricted to a set of second and third layer guards, which have randomized rotation times as defined in that proposal. Basically, now all the hops of onion service circuits are pinned to specific nodes instead of sampling random ones from the whole network every time.</p>
<p>This change to fixed nodes for the second and third layer guards is designed to force the adversary to have to run many more nodes, and to execute both an active sybil attack, as well as a node compromise attack. In particular, the addition of second layer guard nodes means that the adversary goes from being able to discover your guard in minutes by running just one middle node, to requiring them to sustain the attack for weeks or even months, even if they run 5% of the network.</p>
<p>The analysis behind our choice for the number of guards at each layer, and for rotation duration parameters is <a href="https://github.com/asn-d6/vanguard_simulator/wiki/Optimizing-vanguard-topologies">available on GitHub</a>. Here is how our current vanguard<em> 2-3-8 </em>topology looks like:</p>
<p class="text-align-center"><a href="https://raw.githubusercontent.com/asn-d6/vanguard_simulator/illustrations/illustrations/vanguard_system.jpg"><img height="400" src="https://raw.githubusercontent.com/asn-d6/vanguard_simulator/illustrations/illustrations/vanguard_system.jpg" /></a></p>
<p>Furthermore, to better protect the identity of these new pinned guard nodes the circuit lengths have been altered for rendezous point circuits, hidden service directory circuits, and introduction point circuits. You can see them here (where L1 is the first layer guard, L2 is second layer guard, L3 is third layer guard, M is random middle): </p>
<p></p><center><a href="https://raw.githubusercontent.com/asn-d6/vanguard_simulator/illustrations/illustrations/new_paths.jpg"><img height="400" src="https://raw.githubusercontent.com/asn-d6/vanguard_simulator/illustrations/illustrations/new_paths.jpg" /> </a></center>
<h3>Bandguards</h3>
<p>Additionally, the<strong> Bandguards component</strong> of the add-on also checks for evidence of bandwidth side channel attacks, which may be used by the adversary to aid/amplify traffic analysis attacks.</p>
<p>When these attacks are detected, the circuit is (optionally) closed.</p>
<p>Note that the Bandguards component also closes any circuit older than 24 hours (the `circ_max_age_hours` setting), and has an option (off-by-default) to close circuits that transmit more than a certain number of megabytes (the `circ_max_megabytes` option).</p>
<p><b>If your service requires large file uploads, or very long-lived circuits, set these options to 0 in your <a href="https://github.com/mikeperry-tor/vanguards/blob/master/vanguards-example.conf#L68">vanguards.conf</a></b>.</p>
<h3>Rendguards</h3>
<p>Finally, the <strong>Rendguards component </strong>of the add-on performs analysis on the prevalence of rendezvous points on the onion service side. The rendezvous point is chosen by the client when it connects to an onion service, and some attacks rely on the use of a malicious rendezvous point to aid in traffic analysis.</p>
<p>This component tracks the frequency of rendezvous point use, and when it finds overuse, it optionally closes circuits from that rendezvous point and emits a log message.</p>
<p>Each of these components is <strong>configurable</strong>. Please see <a href="https://github.com/mikeperry-tor/vanguards/blob/master/README.md">the README</a> for more information.</p>
<h1>Requirements, Installation, Usage, and Caveats</h1>
<p>The Vanguards add-on is primarily for high-risk onion service operators at this point. In order for the Bandguards side channel detection features to be enabled, Tor 0.3.4.4 or above is required, but the script will run with Tor 0.3.3.x+. Earlier Tors do not have sufficient Control Port support for the script, however.</p>
<p>Additionally, while they have been thoroughly tested by us, the parameters for the various detection mechanisms of the Bandguards and Rendgaurd components are still experimental and may need fine tuning for your service or scenario, especially if it differs from our testing environment.</p>
<p><b><i>If you notice log messages or alarms from these components, it does not necessarily mean that you are under attack.</i></b> If you can, please report frequent log messages to the <a href="https://github.com/mikeperry-tor/vanguards/issues">GitHub issue tracker</a>.</p>
<p>Thank you and let us know if you have any questions or concerns! :)</p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/onion-services">
          onion services
        </a>
      </li><li>
        <a href="../category/research">
          research
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-276170"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276170" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>yuki (not verified)</span> said:</p>
      <p class="date-time">July 20, 2018</p>
    </div>
    <a href="#comment-276170">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276170" class="permalink" rel="bookmark">So you traded the chance of…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>So you traded the chance of randomly selecting an adversarial middle node over time (along with those caveats of having to own a large stake in the network, and shaping node awareness) for the chance of selecting an adversarial node the first time. If you get lucky the first time (short rotation adversarial, or long rotation non adversarial ): great. If you get unlucky the first time (long rotation time adversarial, short rotation non-adversarial): you're still SOL, possibly more so.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276172"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276172" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 20, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276170" class="permalink" rel="bookmark">So you traded the chance of…</a> by <span>yuki (not verified)</span></p>
    <a href="#comment-276172">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276172" class="permalink" rel="bookmark">That&#039;s correct. It is also…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>That's correct. It is also the same trade-off we made when first deploying Guard nodes very early in Tor's history.</p>
<p>For onion services, the key thing that makes this worthwhile is that the adversary gets to force you to create as many circuits as they like, by continuously connecting to you. So if you are actually under attack, it is strictly better to use restricted second and third layer guards that rotate slower than your circuit creation.</p>
<p>For onion clients, it is a bit more fuzzy since it is harder to get them to build lots of circuits. But, if the adversary only controls a small percentage of the network, you're still more likely to get lucky than be SOL right away, as you say.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276174"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276174" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>yuki (not verified)</span> said:</p>
      <p class="date-time">July 20, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-276174">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276174" class="permalink" rel="bookmark">Not exactly the same…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Not exactly the same tradeoff. Guards obtain their status flag by relaying massive amounts of data compared to relay-only. To have made a single poor choice of guard is not immediately a failure of the network goal since guards which do not serve their purpose lose the status. It may be easy for a adversarial to perform some analysis, but a surveilled guard is not as vulnerable.</p>
<p>So here you have a trade off explicitly for onion services to mitigate the number of connections being abused to identify ips of possible interest. I'd admit it would be a hard choice except that onion services that want to stay anonymous should be trying to blend in with other clients in the first place. They could do this by choosing guards that service many requests but that won't stop the issue of paramount concern; as you mentioned. </p>
<p>Why doesn't the guard recognize that *any* deviance in number of concurrent connections from possible client behavior *is* a threat. It doesn't matter if it's a client or onion service. Could not the guard throttle concurrent connections and total bandwidth to a "client" as a defensive measure? It sounds like a sacrifice but the services that count on it probably don't want to stand out. mtc.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276178"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276178" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 20, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276174" class="permalink" rel="bookmark">Not exactly the same…</a> by <span>yuki (not verified)</span></p>
    <a href="#comment-276178">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276178" class="permalink" rel="bookmark">Deploying a defense at the…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Deploying a defense at the guard node against dos/circuit churn attacks against services isn't really feasible because the guard node can't tell if the service is actually under attack or just suddenly popular.</p>
<p>I thought about adding configurable rate limits on the total number of circuits before sounding some sort of alarm in this vanguards addon, but even that is iffy. Even a quiet service can suddenly get a lot of unexpected attention if it goes viral. </p>
<p>Plus, any sort of limits like this are inherently DoS vectors to take down a service.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276219"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276219" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>yuki (not verified)</span> said:</p>
      <p class="date-time">July 23, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-276219">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276219" class="permalink" rel="bookmark">I&#039;m talking about those…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I'm talking about those situations (suddenly popular==measurably bad), so the extra attention you describe is undoubtedly an attack vector against the onion service in active exploitation (or client doing something reckless). (and in the case of the service is having to be mitigated at the client when it's too late) The design proposed benefits adversarial nodes the most as they stand to gain from the status-quo the current design offers. Suppose you can say with some certainty the guards chosen are non-adversarial. Then adversarial nodes stand to benefit from these non-adversarial becoming more associated/connected, more nodes to target, and a way to shift network topology to an adversarial benefit.</p>
<p>Now suppose worse case for an onion service trying as I describe to not stand out. By enforcing the behavior at the guard, these "clients" all look relatively similar, and deprives the successful adversary of benefit. Those who are expected to be targeting these onion services can only succeed if they also simultaneously own multiple guards (perhaps being used to scale).</p>
<p>It would slow down the service, but if the operator sees that warning, continues for whatever reason, then they likely need the service for support. I would be recreating the onion address. So slower is okay, clear warnings okay too. The adversary also needs to experience the churn, and by deflecting at the guard no benefit is gained from surveilling a single non-adversarial guard.</p>
<p>I do see what you mean about the proposed design helping those onion services where suddenly popular==no problem. For some (I'd think many/most) this behavior is undesirable.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276230"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276230" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 23, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276219" class="permalink" rel="bookmark">I&#039;m talking about those…</a> by <span>yuki (not verified)</span></p>
    <a href="#comment-276230">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276230" class="permalink" rel="bookmark">Look I dunno (non-gendered)…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Look I dunno (non-gendered) dude.. Nodes like "being connected and stuff" is kinda vague (maybe you mean fingerprinting? search the comments of this post for that thread). As is how to have the entire network enforce an appropriate set of heuristics on how onion services get used at the guard node...</p>
<p>I'm a little on the yolo side myself but I still deal in science over here. To me, the tradeoffs are clear. If you do not use this addon, the adversary can find your guard in a hot minute (which is much shorter than a wall-clock minute ;), and can use a whole treasure chest of unfixed-in-core-tor attacks to confirm this, observe the guard, and then find your IP address. If you do use this addon, you are making use of the best ways we know of to slow down these attacks. Just a little bit before they go into core-tor.</p>
<p>But maybe you know how to yolo with the wingnut opsec better than I do. That's why it is an addon! Best of luck!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276243"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276243" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>yuki (not verified)</span> said:</p>
      <p class="date-time">July 25, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-276243">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276243" class="permalink" rel="bookmark">translation: it&#039;s ok for…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>translation: it's ok for situationally adversarial nodes to exploit this design, ignoring the undesirable, to say disclose location of a network peer acting contrary to sponsor interests (oh, I don't know like to politics of copyright enforcement), versus situationally being non-adversarial when the peer *is* acting in alignment with sponsor interest (like, oh, I don't know supporting insurgency against perceived anti-competitive political structure, ie. supporting regime change)</p>
<p>You do realize that what you just said sounds like: a) I tried something like that to prevent abuse and failed, and b) you're clearly in opposition to situationally adversarial nodes, which by transitivity means c) you would support such a node when acting in the interest of aligned political powers and simultaneously when acting exclusively in network interest.</p>
<p>Not sure what to make of the rest of your comment, but all I really wanted to know was if research besides your failed attempt has been made. And whether a ticket to seriously investigate the matter exists.</p>
<p>But hey, if your response: The USA is great!, is actually what you meant, all the power to you. Otherwise sorry for misunderstanding.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-276221"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276221" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>yuki (not verified)</span> said:</p>
      <p class="date-time">July 23, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-276221">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276221" class="permalink" rel="bookmark">besides what I said before a…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>besides what I said before a client side script can verify expected guard behavior so that adversarial guards are detectable.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div></div></div><a id="comment-276176"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276176" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 20, 2018</p>
    </div>
    <a href="#comment-276176">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276176" class="permalink" rel="bookmark">Yay finally Mike Perry does…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Yay finally Mike Perry does some research!! We love you Mike you're always making us proud when supporting Tor! Keep it up, proud of ya</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-276179"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276179" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>provider (not verified)</span> said:</p>
      <p class="date-time">July 20, 2018</p>
    </div>
    <a href="#comment-276179">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276179" class="permalink" rel="bookmark">I am hosting V3 onions…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I am hosting V3 onions already and this news terrifies me. Should I delete private_key and generate new V3 onions for my services each month or what?</p>
<p>Tor is not secure at all if 3rd party can know my hosting IP address.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276180"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276180" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 20, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276179" class="permalink" rel="bookmark">I am hosting V3 onions…</a> by <span>provider (not verified)</span></p>
    <a href="#comment-276180">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276180" class="permalink" rel="bookmark">This addon provides the best…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>This addon is designed to make it as hard as possible for someone to determine the IP address of an onion service. Success of an attack depends on the adversary's ability to run large portions of the Tor network <strong>in addition to being able to compromise honest nodes</strong>.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276187"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276187" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-276187">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276187" class="permalink" rel="bookmark">Hi mike, I just don&#039;t…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi mike, I just don't understand why this is a firefox add-on.<br />
Many people are using Chrome over Tor(according to my access.log) and they can't use your addon because they proxy Chrome traffic over Tor's SOCKSport.</p>
<p> Simple question: Why not implement it to Tor core?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276189"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276189" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  asn
  <div class="field field--name-field-display-name field--type-string field--label-visually_hidden">
    <div class="field--label sr-only">Display Name</div>
              <div class="field--item">George Kadianakis</div>
          </div>
</article>
    <div class="comment-header">
      <p class="comment__submitted"><a class="tor" title="View user profile." href="/user/33">George Kadianakis</a> said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276187" class="permalink" rel="bookmark">Hi mike, I just don&#039;t…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-276189">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276189" class="permalink" rel="bookmark">It&#039;s not a firefox add-on,…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>It's not a firefox add-on, it's a Tor core add-on written in Python and uses the control port.</p>
<p>It is not directly implemented in Tor core because it would have been much harder to do it if we had to write it in C and integrate it with all the other modules of Tor core (like the guard subsystem). Hence we are working around that by deploying it as an add-on that uses the control port.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276191"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276191" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276189" class="permalink" rel="bookmark">It&#039;s not a firefox add-on,…</a> by <a class="tor" title="View user profile." href="/user/33">George Kadianakis</a></p>
    <a href="#comment-276191">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276191" class="permalink" rel="bookmark">For maintenance purpose,…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>For maintenance purpose, please consider adding it to your dist.tpo so I can<br />
install it by "apt install vanguard" easily.</p>
<p>To reduce attack surface, my website server is running without any unnecessary things such as 'git'. It'll be nice if this tool is simpler &amp; easy to use.</p>
<p>e.g.<br />
apt install vanguard<br />
vanguard --configure (will open config file with nano)<br />
service vanguard start (will start as daemon)<br />
service vanguard stop (will kill the daemon)</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276197"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276197" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276191" class="permalink" rel="bookmark">For maintenance purpose,…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-276197">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276197" class="permalink" rel="bookmark">Yes debian packages are…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Yes debian packages are definitely on the TODO list. If you want to speed this along, we'd happily accept a pull request or other packaging assistance.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div></div></div></div><a id="comment-276184"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276184" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span content="Instead of defaulting to 3 hops onion....">Instead of def… (not verified)</span> said:</p>
      <p class="date-time">July 20, 2018</p>
    </div>
    <a href="#comment-276184">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276184" class="permalink" rel="bookmark">just use 4-hop onions as…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>just use 4-hop onions as default, and don't worry about the middle node reading the guard node... ... ...my 3 cents</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276185"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276185" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 20, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276184" class="permalink" rel="bookmark">just use 4-hop onions as…</a> by <span content="Instead of defaulting to 3 hops onion....">Instead of def… (not verified)</span></p>
    <a href="#comment-276185">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276185" class="permalink" rel="bookmark">No, unfortunately as soon as…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>No, unfortunately as soon as a malicious middle node is chosen next to your guard node on one of the (many) circuits that the adversary creates, a specially timed stream of data can be used to determine that it is in fact present in the circuit and next to your guard, regardless of the number of hops in your path. See the README for more details: <a href="https://github.com/mikeperry-tor/vanguards/blob/master/README.md" rel="nofollow">https://github.com/mikeperry-tor/vanguards/blob/master/README.md</a></p>
<p>And see <a href="https://petsymposium.org/2018/files/papers/issue2/popets-2018-0011.pdf" rel="nofollow">https://petsymposium.org/2018/files/papers/issue2/popets-2018-0011.pdf</a> for the latest research paper on this type of attack.</p>
<p>This is why this addon restricts the number of nodes that can be in the second and third hop, <strong>and</strong> puts hard limits on the data that can be sent down a Tor circuit that is dropped by the client (and also optionally limits the total amount of data sent on a Tor circuit).</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276228"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276228" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span content="thz. for popets-2018-0011.pdf">thz. for popet… (not verified)</span> said:</p>
      <p class="date-time">July 23, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-276228">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276228" class="permalink" rel="bookmark">is the counter weakness…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>is the counter weakness fixed in any TOR version??</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-276186"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276186" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Hello (not verified)</span> said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
    <a href="#comment-276186">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276186" class="permalink" rel="bookmark">Is the script using Python 2…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Is the script using Python 2 or 3 ?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276195"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276195" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276186" class="permalink" rel="bookmark">Is the script using Python 2…</a> by <span>Hello (not verified)</span></p>
    <a href="#comment-276195">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276195" class="permalink" rel="bookmark">Your choice. Travis runs the…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Your choice. Travis runs the unit test suite on both Python 2.7 and 3.5 on every commit. The local tox script will also run the tests with pypy, if it is installed (Travis is a nightmare to get to work with pypy). There is 99% code coverage (the missing 1% is actually a couple lines of glue that check for python2 vs 3, so they are actually alternately covered in the python2 and python3 tests).</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-276190"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276190" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
    <a href="#comment-276190">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276190" class="permalink" rel="bookmark">As a V3 website owner,…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>As a V3 website owner, should I start using bridge to connect to the network?<br />
Currently I'm directly connecting to the Tor.</p>
<p>Me ----&gt; tor-network[Tor1 - Tor2 - Tor3]</p>
<p>But you're saying Tor1(guard) can be found, so:</p>
<p>Me ---&gt; Tor Bridge ---&gt; network[Tor1 - Tor2 - Tor3]</p>
<p>Will this decrease deanonymization? If so, which bridge should I use? meek/obfs4/suggestion please...</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276196"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276196" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276190" class="permalink" rel="bookmark">As a V3 website owner,…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-276196">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276196" class="permalink" rel="bookmark">Without the vanguards addon,…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Without the vanguards addon, these same attacks will work to find the bridge your onion service is using. So using a bridge by itself is not a defense. However, using a bridge <strong>with</strong> this addon will provide some additional benefit. Namely, if the bridge is not well-known, it can help obscure the fact that your onion service server is connecting to the Tor network, because the traffic from your onion service into the Tor network will be obfuscated. If meek still works, it is probably the best option, but I think meek no longer works well because the major cloud providers started blocking it -- <a href="https://arstechnica.com/information-technology/2018/04/google-disables-domain-fronting-capability-used-to-evade-censors/" rel="nofollow">https://arstechnica.com/information-technology/2018/04/google-disables-…</a> -- so obfs4 or basket may be the best choice. I would use two bridges.</p>
<p>I have not tested using the addon with bridges though. If you run into problems, please file them at <a href="https://github.com/mikeperry-tor/vanguards/issues" rel="nofollow">https://github.com/mikeperry-tor/vanguards/issues</a> (or comment here).</p>
<p>A related option is running a relay on your onion service machine to try to blend your traffic in with other relay traffic. However, this setup has downsides. In particular, it requires some hacky configuration to prevent other side channel leaks: <a href="https://trac.torproject.org/projects/tor/ticket/16824" rel="nofollow">https://trac.torproject.org/projects/tor/ticket/16824</a>. Additionally, downtime of that relay will be strongly correlated with your onion service downtime, which over time can leak the fact that they are on the same machine. So this is also a difficult trade-off at the moment.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276198"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276198" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to mikeperry</p>
    <a href="#comment-276198">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276198" class="permalink" rel="bookmark">Thank you for your reply. I…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Thank you for your reply. I will definitely try this once these are solved:</p>
<p>1. install/update via APT<br />
2. Wiki document (easy to understand)<br />
3. ExcludeNodes support (I'm using "EN default,{us}")</p>
<p>Hope some geeks help on these tasks...</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276223"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276223" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 23, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276198" class="permalink" rel="bookmark">Thank you for your reply. I…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-276223">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276223" class="permalink" rel="bookmark">This is a great priority…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>This is a great priority list. Here's one based on it, which I intend to follow in this order. People are helping with debian packages already! yay.</p>
<p>1. install/update via APT<br />
2. Test bridge support, fix any bugs, and write up setup in README.<br />
3. Separate README into setup+install instructions and a separate TECHNICAL_DETAILS doc.<br />
4. ExcludeNodes support (esp country and netmask rules, eg - "EN default,{us},8.8.8.8/8")</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div></div><a id="comment-276199"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276199" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>mig5 (not verified)</span> said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
    <a href="#comment-276199">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276199" class="permalink" rel="bookmark">Are there any implications…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Are there any implications for using Vanguards with the HiddenServiceSingleHopMode setting enabled? Maybe irrelevant but unsure if there's any collision here in terms of Onion Service discovery (or, e.g, if HiddenServiceSingleHopMode renders the benefit of Vanguards obsolete for the server side?)</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276201"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276201" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  asn
  <div class="field field--name-field-display-name field--type-string field--label-visually_hidden">
    <div class="field--label sr-only">Display Name</div>
              <div class="field--item">George Kadianakis</div>
          </div>
</article>
    <div class="comment-header">
      <p class="comment__submitted"><a class="tor" title="View user profile." href="/user/33">George Kadianakis</a> said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276199" class="permalink" rel="bookmark">Are there any implications…</a> by <span>mig5 (not verified)</span></p>
    <a href="#comment-276201">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276201" class="permalink" rel="bookmark">Onion services with…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Onion services with HiddenServiceSingleHopMode enabled do not use entry guards because they don't benefit from them (since they are not anonymous), hence there is no point for guard discovery attack or deanonymization attacks there.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-276200"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276200" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>71am (not verified)</span> said:</p>
      <p class="date-time">July 21, 2018</p>
    </div>
    <a href="#comment-276200">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276200" class="permalink" rel="bookmark">Hi everyone from Russia !!
I…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi everyone from Russia !!<br />
I am reading this , and dont understand anything ]]<br />
Because i'm just starting explore this , and just can to start tor or i2p on my device .<br />
But i know , what this is most inportant in our life .<br />
Thank you , see you .<br />
Bye .</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-276202"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276202" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 22, 2018</p>
    </div>
    <a href="#comment-276202">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276202" class="permalink" rel="bookmark">Wouldn&#039;t this be more…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Wouldn't this be more dangerous now since it would make the network fingerprint stand out and since you didn't add the necessary padding (yet) to make the network fingerprint look about the same across the board?</p>
<p>Thanks for your work Mike and George</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276220"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276220" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 23, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276202" class="permalink" rel="bookmark">Wouldn&#039;t this be more…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-276220">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276220" class="permalink" rel="bookmark">There are two ways that this…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>There are two ways that this addon will alter your network fingerprint.</p>
<p>The first is observable by a local observer watching your connections into the Tor network. They would now see you're using your two entry guards slightly differently than how stock Tor uses its two guards today. We're working on making all existing stock Tor clients use two guards in a more balanced way (which is possible with a consensus parameter change), but it takes a lot of effort to convince the whole herd of cats that this should be done sooner rather than later. The hard part is that the counter argument against making all clients use two guards in a balanced way is "Whaaaaa?? I thought  Tor was using ONE GUARD. WE SHOULD FIX THAT." Except making stock Tor actually use one guard is even harder, and opens up more low-resource attacks, too.</p>
<p>While this fingerprinting vector could be eliminated by setting the vanguards configuration option <strong>num_layer1_guards</strong> to 1 instead of its current default of 2, it turns out that telling Tor to use only one guard as an onion service opens up a very noisy side channel + confirmation attack that can be detected by this same local observer (because it is possible for them to force a "single entry guard" onion service to use a second guard at specific times).</p>
<p>The second way your network fingerprint differs when you use this addon is that your guard nodes will see that your Tor client is only connecting to a restricted set of middle hops instead of the whole network (unless you also use that same Tor client to also connect to the external Internet). At this time, there are a lot of other traffic analysis vectors that can be used to fingerprint a hidden service if you control the guard node, though.</p>
<p>In both cases, I personally feel that the benefit from protecting against guard discovery outweighs the additional fingerprinting risk from these two vectors. And in the long term, we can mitigate/obscure them, too.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-276206"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276206" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 22, 2018</p>
    </div>
    <a href="#comment-276206">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276206" class="permalink" rel="bookmark">1. How can we know that our…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>1. How can we know that our onion service is compromized(attacker know Guard node)?<br />
2. Doesn't this mean we should rotate .onion domain daily|monthly|yearly?<br />
3. If 3 is true, why not make a torDNS system?</p>
<p>xyz.tor --resove---&gt; xyzonionnamenow.onion</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-276207"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276207" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 23, 2018</p>
    </div>
    <a href="#comment-276207">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276207" class="permalink" rel="bookmark">That&#039;s good to have current…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>That's good to have current stable tor in Debian torproject's repository, but why other widely used projects like stem and nyx are not in this repo? Without stem (or with outdated stem) I cannot test many tools (including this vanguards tool).</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-276209"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276209" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>s7r (not verified)</span> said:</p>
      <p class="date-time">July 23, 2018</p>
    </div>
    <a href="#comment-276209">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276209" class="permalink" rel="bookmark">I am so happy to see the …</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I am so happy to see the "Rendguards" component here. Thank you so much for taking it into consideration. While I honestly think all here is great work, just using Rendguards feature set to 2.0 as it is the default value currently in vanguards.conf is a huge win. I know for sure from a tipper that this malicious rendezvous relay overuse attack was used to discover the Guard of a V2 onion service, and after that the guard in question was just watched at its ISP level, with no clue or track to the guard operator. </p>
<p>It's true that an attacker can overuse honest relays by deliberately choosing them as rendezvous points, but this depends on the popularity of the onion service as well. Basically, the more popular an onion service is (and more honest non attacking clients connecting to it) the harder is to fool it with such false positives. As an attacker uses this method to ban more and more relays as being used for rendezvous point position, the total number of established rendezvous circuits will grow and more effort will be required to ban new relays. At least this becomes a very noisy attack, very visible to the onion service operator.</p>
<p>I am not sure why this parameter is set at this value: rend_use_scale_at_count = 1000<br />
Wouldn't a bigger number do much better here? Like 100000 or even 500000? Is it that expensive to keep track of this number of rend circuits and apply the filter over them?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276231"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276231" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  mikeperry
  </article>
    <div class="comment-header">
      <p class="comment__submitted">mikeperry said:</p>
      <p class="date-time">July 23, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276209" class="permalink" rel="bookmark">I am so happy to see the …</a> by <span>s7r (not verified)</span></p>
    <a href="#comment-276231">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276231" class="permalink" rel="bookmark">This is a great question s7r…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>This is a great question s7r. There is a TODO question in the source about this. The statistical test we should really be doing should be based on "Statistical Confidence Intervals", and also factor in a bunch of variables about our assumptions about how fast we want to react to new nodes, etc.</p>
<p>However, the intuition is that the larger the scale_at variable, the slower the script can react to new nodes suddenly entering the network with the purposes of attacking a node. So setting this as low as possible while still not triggering false positives seems like the right move, at least until we have better models on this attack.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-276271"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276271" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>jhoncoder (not verified)</span> said:</p>
      <p class="date-time">July 30, 2018</p>
    </div>
    <a href="#comment-276271">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276271" class="permalink" rel="bookmark">Hi all, i&#039;m running a v3…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi all, i'm running a v3 onion service and Vanguard. All ok in tor and vanguard logs but TorBrowser says: Unable to connect.</p>
<p>How much time should I wait to stablish new circuits with Vanguard?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276279"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276279" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  asn
  <div class="field field--name-field-display-name field--type-string field--label-visually_hidden">
    <div class="field--label sr-only">Display Name</div>
              <div class="field--item">George Kadianakis</div>
          </div>
</article>
    <div class="comment-header">
      <p class="comment__submitted"><a class="tor" title="View user profile." href="/user/33">George Kadianakis</a> said:</p>
      <p class="date-time">July 31, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276271" class="permalink" rel="bookmark">Hi all, i&#039;m running a v3…</a> by <span>jhoncoder (not verified)</span></p>
    <a href="#comment-276279">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276279" class="permalink" rel="bookmark">Hm that&#039;s weird. Are there…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hm that's weird. Are there any weird logs on the client-side or on the service-side?<br />
It should usually work immediately. What happens if you wait some more time?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-276317"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276317" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>jhoncoder (not verified)</span> said:</p>
      <p class="date-time">August 05, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-276279" class="permalink" rel="bookmark">Hm that&#039;s weird. Are there…</a> by <a class="tor" title="View user profile." href="/user/33">George Kadianakis</a></p>
    <a href="#comment-276317">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276317" class="permalink" rel="bookmark">&gt;What happens if you wait…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>&gt;What happens if you wait some more time?</p>
<p>Not work. If i remove vanguard all working well immediately.</p>
<p>No weird info in the tor logs, and vanguard log=debug not show weird info</p>
<p>I have two hidden services, not one. affects it?</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-276311"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276311" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Newbie (not verified)</span> said:</p>
      <p class="date-time">August 03, 2018</p>
    </div>
    <a href="#comment-276311">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276311" class="permalink" rel="bookmark">This tool is totally useless…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>This tool is totally useless when I can't install it in python2.7 (install, pyQT installed)<br />
I actually don't know how to install it, your guide is too poor for a newbie.<br />
Can anyone help me please?<br />
Windows 7</p>
<p>Thanks</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-276371"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276371" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>highlight (not verified)</span> said:</p>
      <p class="date-time">August 13, 2018</p>
    </div>
    <a href="#comment-276371">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276371" class="permalink" rel="bookmark">Does anyone know how to get…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Does anyone know how to get this addon to work with Tor Browser that is sandboxed? I have gotten it to work with the regular tor browser. Also can this be used on Tor Browser and Tor network running at same time? Or I guess it could be done using a different control port and running two instances of vanguard?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-276609"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-276609" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>watsyrnm (not verified)</span> said:</p>
      <p class="date-time">August 31, 2018</p>
    </div>
    <a href="#comment-276609">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-276609" class="permalink" rel="bookmark">You can try to simulate some…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>You can try to simulate some fake-host in random places to reduce the capacity of the detectors to reach some real-host using IoT devices... That forces to the detectors to deploy more attacks over fake random host/places.Just an idea.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-278049"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278049" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>matheu (not verified)</span> said:</p>
      <p class="date-time">October 15, 2018</p>
    </div>
    <a href="#comment-278049">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278049" class="permalink" rel="bookmark">&gt; Also can this be used on…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>&gt; Also can this be used on Tor Browser and Tor network running at same time?<br />
You mean plain standalone tor install, running possibly as daemon, and Tor Browser? And both as clients only.<br />
If so, than some kind of onionbalance for clients should be deployed, reasons just as in:<br />
Synchronize layer2+layer3 guards when using OnionBalance · Issue #12 · mikeperry-tor/vanguards · GitHub<br />
<a href="https://github.com/mikeperry-tor/vanguards/issues/12" rel="nofollow">https://github.com/mikeperry-tor/vanguards/issues/12</a><br />
I.e. two tors: double exposure of guards used.<br />
I'm nterested if this can be achieved, and how. Obviously not the same, but similar way to OnionBalance...</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-278127"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278127" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>matheu (not verified)</span> said:</p>
      <p class="date-time">October 18, 2018</p>
    </div>
    <a href="#comment-278127">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278127" class="permalink" rel="bookmark">mike, I&#039;d file an issue with…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>mike, I'd file an issue with your vanguards on github, but M$ won't allow anonymous registration, so I'll attempt to post about it here.<br />
This is the command to start vanguards from source:<br />
./vanguards/src/vanguards.py --loglevel NOTICE --logfile log.vanguards<br />
and pretty similarly with another instance for another Tor.<br />
Importantly, I get DEBUG lines out. Such as:<br />
DEBUG[Thu Oct 18 16:40:19 2018]: 650 CIRC 2730 BUILT $XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX~somename,$XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX~someothername,$XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX~yetothername,$XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX~othername BUILD_FLAGS=IS_INTERNAL,NEED_CAPACITY PURPOSE=HS_VANGUARDS TIME_CREATED=2018-10-18T16:40:19.444383<br />
If that isn't a bug, but intended behavior, maybe I don't connect something here...</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-278339"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278339" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>anony666-8 (not verified)</span> said:</p>
      <p class="date-time">October 30, 2018</p>
    </div>
    <a href="#comment-278339">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278339" class="permalink" rel="bookmark">Same for me, I cannot…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Same for me, I cannot register an anonymous account on github for opening an issue.<br />
It is a serious problem for a project like Tor.</p>
<p>I cannot run run vanguard</p>
<p><div class="geshifilter"><pre class="php geshifilter-php" style="font-family:monospace;"><ol><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal"><span style="color: #339933;">./</span>src<span style="color: #339933;">/</span>vanguards<span style="color: #339933;">.</span>py <span style="color: #339933;">--</span>control_port <span style="color: #cc66cc;">9099</span><span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">NOTICE<span style="color: #009900;">&#91;</span>Wed Oct <span style="color: #cc66cc;">31</span> <span style="color: #208080;">01</span><span style="color: #339933;">:</span><span style="color: #cc66cc;">49</span><span style="color: #339933;">:</span><span style="color: #cc66cc;">43</span> <span style="color: #cc66cc;">2018</span><span style="color: #009900;">&#93;</span><span style="color: #339933;">:</span> Creating <span style="color: #000000; font-weight: bold;">new</span> vanguard state <a href="http://www.php.net/file"><span style="color: #990000;">file</span></a> at<span style="color: #339933;">:</span> vanguards<span style="color: #339933;">.</span>state<span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">NOTICE<span style="color: #009900;">&#91;</span>Wed Oct <span style="color: #cc66cc;">31</span> <span style="color: #208080;">01</span><span style="color: #339933;">:</span><span style="color: #cc66cc;">49</span><span style="color: #339933;">:</span><span style="color: #cc66cc;">43</span> <span style="color: #cc66cc;">2018</span><span style="color: #009900;">&#93;</span><span style="color: #339933;">:</span> Vanguards 0<span style="color: #339933;">.</span>2<span style="color: #339933;">.</span>3<span style="color: #339933;">.</span>dev0 connected to Tor 0<span style="color: #339933;">.</span>3<span style="color: #339933;">.</span>4<span style="color: #339933;">.</span>8 <span style="color: #009900;">&#40;</span>git<span style="color: #339933;">-</span>5da0e95e4871a0a1<span style="color: #009900;">&#41;</span> using stem 1<span style="color: #339933;">.</span>4<span style="color: #339933;">.</span>1<span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">Traceback <span style="color: #009900;">&#40;</span>most recent call last<span style="color: #009900;">&#41;</span><span style="color: #339933;">:&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">  <a href="http://www.php.net/file"><span style="color: #990000;">File</span></a> <span style="color: #0000ff;">&quot;./src/vanguards.py&quot;</span><span style="color: #339933;">,</span> line <span style="color: #cc66cc;">8</span><span style="color: #339933;">,</span> in <span style="color: #339933;">&lt;</span>module<span style="color: #339933;">&gt;&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">    vanguards<span style="color: #339933;">.</span>main<span style="color: #339933;">.</span>main<span style="color: #009900;">&#40;</span><span style="color: #009900;">&#41;</span><span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">  <a href="http://www.php.net/file"><span style="color: #990000;">File</span></a> <span style="color: #0000ff;">&quot;/root/vanguards/src/vanguards/main.py&quot;</span><span style="color: #339933;">,</span> line <span style="color: #cc66cc;">23</span><span style="color: #339933;">,</span> in main<span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">    run_main<span style="color: #009900;">&#40;</span><span style="color: #009900;">&#41;</span><span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">  <a href="http://www.php.net/file"><span style="color: #990000;">File</span></a> <span style="color: #0000ff;">&quot;/root/vanguards/src/vanguards/main.py&quot;</span><span style="color: #339933;">,</span> line <span style="color: #cc66cc;">62</span><span style="color: #339933;">,</span> in run_main<span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">    ret <span style="color: #339933;">=</span> control_loop<span style="color: #009900;">&#40;</span>state<span style="color: #009900;">&#41;</span><span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">  <a href="http://www.php.net/file"><span style="color: #990000;">File</span></a> <span style="color: #0000ff;">&quot;/root/vanguards/src/vanguards/main.py&quot;</span><span style="color: #339933;">,</span> line <span style="color: #cc66cc;">99</span><span style="color: #339933;">,</span> in control_loop<span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">    state<span style="color: #339933;">.</span>new_consensus_event<span style="color: #009900;">&#40;</span>controller<span style="color: #339933;">,</span> None<span style="color: #009900;">&#41;</span><span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">  <a href="http://www.php.net/file"><span style="color: #990000;">File</span></a> <span style="color: #0000ff;">&quot;/root/vanguards/src/vanguards/vanguards.py&quot;</span><span style="color: #339933;">,</span> line <span style="color: #cc66cc;">206</span><span style="color: #339933;">,</span> in new_consensus_event<span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">    exclude_nodes <span style="color: #339933;">=</span> ExcludeNodes<span style="color: #009900;">&#40;</span>controller<span style="color: #009900;">&#41;</span><span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">  <a href="http://www.php.net/file"><span style="color: #990000;">File</span></a> <span style="color: #0000ff;">&quot;/root/vanguards/src/vanguards/vanguards.py&quot;</span><span style="color: #339933;">,</span> line <span style="color: #cc66cc;">60</span><span style="color: #339933;">,</span> in __init__<span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">    <span style="color: #000000; font-weight: bold;">self</span><span style="color: #339933;">.</span>_parse_line<span style="color: #009900;">&#40;</span>controller<span style="color: #339933;">.</span>get_conf<span style="color: #009900;">&#40;</span><span style="color: #0000ff;">&quot;ExcludeNodes&quot;</span><span style="color: #009900;">&#41;</span><span style="color: #009900;">&#41;</span><span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">  <a href="http://www.php.net/file"><span style="color: #990000;">File</span></a> <span style="color: #0000ff;">&quot;/root/vanguards/src/vanguards/vanguards.py&quot;</span><span style="color: #339933;">,</span> line <span style="color: #cc66cc;">75</span><span style="color: #339933;">,</span> in _parse_line<span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">    <span style="color: #b1b100;">if</span> p<span style="color: #009900;">&#91;</span><span style="color: #cc66cc;">0</span><span style="color: #009900;">&#93;</span> <span style="color: #339933;">==</span> <span style="color: #0000ff;">&quot;$&quot;</span><span style="color: #339933;">:&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li><li style="font-family: monospace; font-weight: normal;"><div style="font-family: monospace; font-weight: normal; font-style: normal">IndexError<span style="color: #339933;">:</span> string index out of range<span style="color: #339933;">&lt;</span>br <span style="color: #339933;">/&gt;</span></div></li></ol></pre></div></p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-278675"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278675" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>cypherpunks (not verified)</span> said:</p>
      <p class="date-time">December 03, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-278339" class="permalink" rel="bookmark">Same for me, I cannot…</a> by <span>anony666-8 (not verified)</span></p>
    <a href="#comment-278675">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278675" class="permalink" rel="bookmark">The https://blog.torproject…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>The <a href="https://blog.torproject.org/comment/278339#comment-278339" rel="nofollow">https://blog.torproject.org/comment/278339#comment-278339</a> above appears to me similar to:<br />
<a href="https://github.com/mikeperry-tor/vanguards/issues/1" rel="nofollow">https://github.com/mikeperry-tor/vanguards/issues/1</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-278508"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-278508" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>matheu (not verified)</span> said:</p>
      <p class="date-time">November 17, 2018</p>
    </div>
    <a href="#comment-278508">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-278508" class="permalink" rel="bookmark">I believe in this project …</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>NOTE: the page appears to be broken, trying to post with 8.5a4, my Noscript is at restrictions disabled for this site; the previous poster too appears to have issues. Do not blame me if this comes out poorly, it's the preview doesn't work)</p>
<p>I believe in this project (mildly, not claiming much competence). To me it looks much more prospective, and very much at hand  in comparison to the alternatives mentioned in the FAQ chapter:<br />
<a href="https://www.torproject.org/docs/faq.html#altdesigns" rel="nofollow">Alternate designs that we don't do (yet):</a><br />
(where at this time, Vanguards has no mention there at all).</p>
<p>It would be great to learn whether Tor team is closer to a consensus on deploying Vanguards in Tor itself. Or if it is going for some of the alternatives mentioned in the link... Those certainly do look very far from doable any time soon (and Vanguards works... as we are speaking, in many HS and many clients --although not yet massively, not enough numbers for the disadvantages of running Vanguards addon to be fully compensated, I'd think...)...</p>
<p>But the Tor team may be able to tell us more</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-281047"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-281047" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Onion Service Owner (not verified)</span> said:</p>
      <p class="date-time">May 02, 2019</p>
    </div>
    <a href="#comment-281047">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-281047" class="permalink" rel="bookmark">Are packages still on the…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Are packages still on the TODO list? It's been months and (as far as I'm aware) there are still no packages.</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
